package
{
	import mx.modules.IModuleInfo;
	import mx.events.ModuleEvent;
	import mx.modules.ModuleManager;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import mx.events.FlexEvent;
	import flash.display.Loader;
	import com.permadi.modules.MyModuleBase; 
		 
	public class ExampleModuleManager extends EventDispatcher
	{
		private var mModulesList:Object=null;
		
		public function ExampleModuleManager():void
		{
			mModulesList=new Array();
		}
		
		public function loadModule(moduleURL:String):IModuleInfo
		{
			if (mModulesList[moduleURL]==null)
			{
				var moduleInfo:IModuleInfo=ModuleManager.getModule(moduleURL);
				moduleInfo.addEventListener(FlexEvent.LOADING, onModuleLoading);
				moduleInfo.addEventListener(ModuleEvent.SETUP, onModuleSetup);
				moduleInfo.addEventListener(ModuleEvent.READY, onModuleReady);
				moduleInfo.addEventListener(ModuleEvent.ERROR, onModuleError);
				moduleInfo.addEventListener(ModuleEvent.PROGRESS, onModuleProgress);
				moduleInfo.addEventListener(ModuleEvent.UNLOAD, onModuleUnload);
				
				// We are keeping the URL so we can do back referencing during unload
				moduleInfo.data={moduleURL:moduleURL};
				mModulesList[moduleURL]=new Object();
				mModulesList[moduleURL].moduleInfo=moduleInfo;
				moduleInfo.load();
				trace("loadModule "+moduleURL);
				return null;
			}
			else
			{
				return mModulesList[moduleURL].moduleInfo;
			}
		}		
	
		public function getModuleInstance(moduleURL:String):MyModuleBase
		{
			if (!mModulesList[moduleURL].moduleInstance)
			{
				mModulesList[moduleURL].moduleInstance=mModulesList[moduleURL].moduleInfo.factory.create();
			}
			return mModulesList[moduleURL].moduleInstance;
		}
		
		public function unloadModule(module:MyModuleBase):void
		{
			var moduleInfo:IModuleInfo=mModulesList[module.getModuleURL()].moduleInfo;
			mModulesList[module.getModuleURL()]=null;
			
			moduleInfo.removeEventListener(FlexEvent.LOADING, onModuleLoading);
			moduleInfo.removeEventListener(ModuleEvent.SETUP, onModuleSetup);
			moduleInfo.removeEventListener(ModuleEvent.READY, onModuleReady);
			moduleInfo.removeEventListener(ModuleEvent.ERROR, onModuleError);
			moduleInfo.removeEventListener(ModuleEvent.PROGRESS, onModuleProgress);

						
			moduleInfo.unload();
			trace("unloadModule "+module.getModuleURL());
		}
			
		public function onModuleSetup(event:ModuleEvent):void
		{
			trace("onModuleSetup");
			
		}
				
		public function onModuleLoading(event:FlexEvent):void
		{
			trace("onModuleLoading");
			
		}
		
		public function onModuleReady(event:ModuleEvent):void
		{
			var moduleInfo:IModuleInfo=event.module;
			trace("onModuleReady "+moduleInfo.url);
			dispatchEvent(event);		
		}
		
		public function onModuleError(event:ModuleEvent):void
		{
			trace("onModuleError "+event.errorText);
			
		}

		public function onModuleProgress(event:ModuleEvent):void
		{
			trace("onModuleProgress "+event.bytesLoaded/event.bytesLoaded*100+"%");
		}

		public function onModuleUnload(event:ModuleEvent):void
		{
			trace("onModuleUnload");			
			event.module.removeEventListener(ModuleEvent.UNLOAD, onModuleUnload);			
		}
		
	}
}