package 
{
	import flash.display.MovieClip;
	import mx.modules.IModuleInfo;
	import mx.events.ModuleEvent;
	import mx.modules.ModuleManager;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.display.Loader;
	import flash.display.LoaderInfo;	
	import flash.net.URLRequest;	
	
	import com.permadi.modules.MyModuleBase;
	
	[SWF(width='500', height='400', backgroundColor='#FFFFFF', frameRate='30')]
	public class MultipleModulesExample extends MovieClip
	{
		private var mModuleManager:ExampleModuleManager=null;
		private var mTestShell:MovieClip=null;
		
		// In this example, there is only one module active at a given time.
		// Of course you can have more than one in a real application.
		private var mModule:MyModuleBase=null;
		
		public function MultipleModulesExample()
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onInterfaceMovieLoaded);
			var params:Object=LoaderInfo(this.root.loaderInfo).parameters;;
			loader.load(new URLRequest("TestShell.swf"));
			mModuleManager=new ExampleModuleManager();   
			mModuleManager.addEventListener(ModuleEvent.READY, onModuleReady);				
		}
		
		public function onInterfaceMovieLoaded(event:Event):void
		{
			mTestShell=event.target.content;	
			mTestShell.btn_loadModule.addEventListener(MouseEvent.CLICK, onLoadModuleButtonClicked);
			mTestShell.btn_unloadModule.addEventListener(MouseEvent.CLICK, onUnloadModuleButtonClicked);
			mTestShell.btn_clearConsole.addEventListener(MouseEvent.CLICK, onClearConsoleButtonClicked);
			mTestShell.btn_execute.addEventListener(MouseEvent.CLICK, onCalculateButtonClicked);
			mTestShell.btn_execute.visible=false;			
			addChild(mTestShell);
			//event.target.		
		}
		
		public function onClearConsoleButtonClicked(event:MouseEvent):void
		{
			mTestShell.mc_textArea.text="";
		}
		
		public function onLoadModuleButtonClicked(event:MouseEvent):void
		{			
			// In this example, the Module class names are hard coded in the mTestShell SWF.
			var moduleURL:String="com/permadi/modules/"+mTestShell.combo_moduleList.selectedLabel+".swf";
			mTestShell.mc_textArea.appendText("\nLoading "+moduleURL);
			var moduleInfo:IModuleInfo=mModuleManager.loadModule(moduleURL);
			if (!moduleInfo)
			{
				mModuleManager.addEventListener(ModuleEvent.READY, onModuleReady);				
			}
			// Already loaded before, so just use the same instance
			else
			{
				mModule=mModuleManager.getModuleInstance(moduleURL);
				mTestShell.btn_execute.visible=true;
				mTestShell.mc_textArea.appendText("\nonModuleReady "+mModule.getModuleName());	
				
				// Execute opration
				onCalculateButtonClicked(null);					
			}
		}

		public function onCalculateButtonClicked(event:MouseEvent):void
		{
			mTestShell.mc_textArea.appendText("\nonCalculateButtonClicked");
			mTestShell.textField_result.text=mModule.performOperation(
				mTestShell.textField_param1.text, 
				mTestShell.textField_param2.text);
		}
		
		public function onUnloadModuleButtonClicked(event:MouseEvent):void
		{
			if (mModule)
			{
				mTestShell.mc_textArea.appendText("\nUnloading "+mModule.getModuleName());
				mTestShell.btn_execute.visible=false;
				mModuleManager.unloadModule(mModule);
				mModule=null;
			}
		}
		
		public function onModuleReady(event:ModuleEvent):void
		{
			mModuleManager.removeEventListener(ModuleEvent.READY, onModuleReady);				
			mModule=mModuleManager.getModuleInstance(event.module.data.moduleURL) as MyModuleBase;
			mModule.setModuleURL(event.module.data.moduleURL);

			mTestShell.btn_execute.visible=true;
			mTestShell.mc_textArea.appendText("\nonModuleReady "+mModule.getModuleName());	
			
			// Execute opration
			onCalculateButtonClicked(null);					
		}
	}
}
